<?php

//video class

class Video
{
	var $uploaddir;
	var $localdir;
	var $vidName;
	var $vidFileDir;
	
	
	var $thumbnail_name;
	var	$thumbnail_width = 150;
	var $thumbnail_height = 150;
	var $thumbnail_dir;
	
	var $thumbnail_img;
	var $thumbnail_localdir;
	

	public function __get($var) {

		return $this->{$var};
	}
	
	public function __set($var, $val)
	{
		$this->{$var} = $val;
	}
	
	public function version()
	{
	$ver  = "<!--\n";
	$ver .= "phpVideo version 0.2\n";
  $ver .= "requires: \n";
  $ver .= "-Flash Video Player ( http://www.jeroenwijering.com/?item=Flash_Video_Player )\n";
	$ver .= "-ffmpeg (http://ffmpeg.mplayerhq.hu/ )\n";
	$ver .= "-PHP5.2 or later";
	$ver .= "\n\nAuthor: Wess Cope <wcope@noisewater.net>Date  updated:3.5.07\n-->\n";
		  
 	return $ver;
	
	}
	
	public function __construct($width = 320, $height = 260, $bgColor = "#eaeaea")
	{
		
		echo $this->version();
		echo "<script language=\"javascript\" src=\"js/ufo.js\"></script>\n";
		echo "<script language=\"javascript\">\n
function playMovie(file)\n{\nvar FO = \n{\nmovie:\"flvplayer.swf\",\nwidth:\"".$width."px\",\nheight:\"".$height."px\",\nmajorversion:\"7\",\nbuild:\"0\",\nbgcolor:\"#eaeaea\",\nflashvars:\"file=\"+file+\"&autoStart=true\"\n};\n
        	
UFO.create(FO, 'player');\n}\n
</script>\n";
	
	}//__construct


	public function upload()
	{
		$files = $_FILES;
		
		/*
		echo '<pre>';
		var_dump($_FILES);
    echo '</pre>';
    */
    
    if($this->uploaddir == '')
    {
    	if(!file_exists('videos/'))
    	{
    		mkdir('videos/');
    		//echo 'making dir';
			}//if
			
	    $this->uploaddir = 'videos/';

    }//if
    
    @$uploadfile = $this->uploaddir . basename($files['file']['name']);
    $this->vidFileDir = $uploadfile;
    
 
    if(@move_uploaded_file($files['file']['tmp_name'], $uploadfile))
    {
        $noExt = explode(".", $files['file']['name']);
        $name = $noExt[0];

        if($noExt[1] == "wmv")
        {
		exec("mencoder ". $this->uploaddir . $files['file']['name'] . " -o " . $this->uploaddir . $name . ".flv -of lavf -oac mp3lame -lameopts abr:br=56 -ovc lavc -lavcopts vcodec=flv:vbitrate=9600:mbd=2:mv0:trell:v4mv:cbp:last_pred=3 -lavfopts i_certify_that_my_video_stream_does_not_use_b_frames -srate 22050");
        	exec("flvtool2 -Uv " . $this->uploaddir . $name . ".flv " . $this->uploaddir . $name . ".flv");
        	
        	$veed = $this->localdir . $name . ".flv";
        	//$this->vidFileDir = $veed;

        	$this->vidName = $name . "flv";

        	
        }
        else
        {
					exec("ffmpeg -i " . $this->uploaddir . $files['file']['name'] . " " . $this->uploaddir . $name . ".flv");
        	$veed = $this->localdir . $name . ".flv";
        	//$this->vidFileDir = $veed;

        	$this->vidName = $name . "flv";
        	
        }
        
        	if(isset($this->thumbnail_name))
        	{
        		$this->thumbnail();
        	}
        	
        	return $veed;
    }
    else
    {
			die("UPLOAD FAILED");
	  }//if/else


	}//uploadVideo
	
	//$file must be a full path -- $thumbdir is where to store the thumbnails
	public function thumbnail() 
	{		
			$flvFileDir = explode(".",$this->vidFileDir);
			$flvFile = $flvFileDir[0] . ".flv";
			
			$file 	= $this->thumbnail_name;
			$width 	= $this->thumbnail_width;
			$height = $this->thumbnail_height;
			$dir		= $this->thumbnail_dir;
			
			if(isset($this->thumbnail_dir))
			{
				$thumbName = $dir . $file . ".jpg";

				//die($flvFile . "<br>" . $thumbName);
				exec("ffmpeg -y -i " . $flvFile . " -f mjpeg -ss 10 -vframes 1 -s " .$width."x".$height." -an " . $thumbName);
				
				$this->thumbnail_img = $this->thumbnail_localdir . $file . ".jpg";
			}
			else
			{
				die("Thumbnail failed: no thumbnail dir set");
			}
			
	}//thumbnail


	public function delVideo($file)
	{
		//$file must be full path
		
		if(file_exists($file))
		{
			unlink($file);
			return true;
		}
		else
		{
			$res = "This file does not exist.";
			return $res;
		}//if/else

	}//delVideo
	
	public function player($veed = '')
	{
		if($veed == '')
		{
			echo "Video source has not been supplied";
			
		}
		else
		{
			if(!file_exists($veed))
				echo "Video file does not exist";
			else
				echo "<script language=\"javascript\">playMovie('".$veed."');</script>";
						
		}//if
			
	}//player

}//Video
