<?php

function timedisplay($input_timestamp) {

	$timestamp = time();
	$difference = $timestamp - $input_timestamp;

	if (!$input_timestamp || !$input_timestamp) {
		echo "Never";
	} 

	if (floor($difference / 84600) > 0) {
	// If number of days is greater than 1

		if (floor($difference / 84600) == "0") {
		// Display nothing, not today!

		} else {
		// Display days ago

			if (floor($difference / 84600) > 365) {

				echo date("$time_an", $input_timestamp);

			} else {

				if (floor($difference / 84600) > 0 && floor($difference / 84600) < 2) {
				// Display "Yesterday"

					echo "Yesterday";

				} else {

					if (floor($difference / 84600) > 1) {
						echo floor($difference / 84600);
						$difference -= 84600 * floor($difference / 84600);
						echo ' days ago';
					}
				}
			}
		}

	} else {

	// Today: Display hours, seconds and minutes ago

		$difference -= 84600 * floor($difference / 84600);

		if (floor($difference / 84600) < 1) {
		// Display number of hours if days less than 1

			if (floor($difference / 3600) < 1) {

				$difference -= 3600 * floor($difference / 3600);
				if (floor($difference / 3600) < 1 && floor($difference / 60) > 1) {
					echo floor($difference / 60);
					echo " mins ago";
				} else {
					if (floor($difference / 3600) == "0") {
						echo "This minute";
					}
				}

			} else {

				if (floor($difference / 3600) < 2) {
					echo floor($difference / 3600);
					$difference -= 3600 * floor($difference / 3600);
					echo ' hour ago';
				} else {
					echo floor($difference / 3600);
					$difference -= 3600 * floor($difference / 3600);
					echo ' hours ago';
				}
			}
		}
	}
	//return "$timenow_ret";
}
//------------------------------------------------------------------------//

function check_today($input_timestamp) {

	$timestamp = time();
	$difference = $timestamp - $input_timestamp;

	if (floor($difference / 84600) > 1 && floor($difference / 84600) < 3) {

		echo "Yesterday";

	} else {
		if (floor($difference / 84600) < 1) {
		echo "Today";
		} else {
		echo date("m/d", $input_timestamp);
		}
	}
}

//------------------------------------------------------------------------//

function date_eta($input_date) {

	$input_fixed = str_replace('', '', $input_date);
	$year = substr($input_fixed, 0,4); 
	$month = substr($input_fixed, 5, 2); 
	$day = substr($input_fixed, 8, 2);

	$release_stamp = mktime(0, 0, 0, $month, $day +1, $year);

	$timestamp = time();
	$difference = $release_stamp - $timestamp;

	if (floor($difference / 84600) == "1") {
		echo floor($difference / 84600) . " day";
	} else {
		echo floor($difference / 84600) . " days";
	}
}

//------------------------------------------------------------------------//

function days_ago($input_timestamp) {

	if ($input_timestamp == "0") {
	} else {

		$timestamp = time();
		$difference = $timestamp - $input_timestamp;

		if (floor($difference / 84600) < 1) {
			echo " (Today)";
		} else {
			echo " (" . floor($difference / 84600) . " days ago)";
		}
	}
}

?>